package hu.elte.korszeru;

import java.io.IOException;

import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapred.FileInputFormat;
import org.apache.hadoop.mapred.FileOutputFormat;
import org.apache.hadoop.mapred.JobClient;
import org.apache.hadoop.mapred.JobConf;
import org.apache.hadoop.mapred.TextInputFormat;
import org.apache.hadoop.mapred.TextOutputFormat;

public class Feladat1Driver {

	public static void main(String[] args) {
		JobClient client = new JobClient();
		JobConf conf = new JobConf(hu.elte.korszeru.Feladat1Driver.class);

		conf.setOutputKeyClass(Text.class);
		conf.setOutputValueClass(IntWritable.class);
		
		conf.set("mapred.reduce.tasks", "0");

		conf.setInputFormat(TextInputFormat.class);
		conf.setOutputFormat(TextOutputFormat.class);
		
		String folder = "Gyak2feladat1Out";
		
		FileInputFormat.setInputPaths(conf, new Path("/user/ggombos/szamok.txt"));
		FileOutputFormat.setOutputPath(conf, new Path(folder));
		
		FileSystem fs;
		try {
			fs = FileSystem.get(conf);
			if (fs.exists(new Path(folder)))
				fs.delete(new Path(folder),true);
		} catch (IOException e1) {
			e1.printStackTrace();
		}

		conf.setMapperClass(hu.elte.korszeru.Feladat1Mapper.class);

//		conf.setReducerClass(hu.elte.korszeru.Feladat1Reducer.class);

		client.setConf(conf);
		try {
			JobClient.runJob(conf);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
