package hu.elte.korszeru;

import java.io.IOException;

import org.apache.hadoop.fs.FileSystem;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.LongWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapred.FileInputFormat;
import org.apache.hadoop.mapred.FileOutputFormat;
import org.apache.hadoop.mapred.JobClient;
import org.apache.hadoop.mapred.JobConf;
import org.apache.hadoop.mapred.TextInputFormat;
import org.apache.hadoop.mapred.TextOutputFormat;
import org.apache.hadoop.mapred.lib.ChainMapper;
import org.apache.hadoop.mapred.lib.ChainReducer;

public class Feladat2Driver {

	public static void main(String[] args) {
		JobConf conf = new JobConf(hu.elte.korszeru.Feladat2Driver.class);

		conf.setOutputKeyClass(Text.class);
		conf.setOutputValueClass(IntWritable.class);

		conf.setInputFormat(TextInputFormat.class);
		conf.setOutputFormat(TextOutputFormat.class);
		
		String folder = "Gyak2feladat2Out";
		FileInputFormat.setInputPaths(conf, new Path("/user/ggombos/twitter/tweet/"));
		FileOutputFormat.setOutputPath(conf, new Path(folder));
		
		FileSystem fs;
		try {
			fs = FileSystem.get(conf);
			if (fs.exists(new Path(folder)))
				fs.delete(new Path(folder),true);
		} catch (IOException e1) {
			e1.printStackTrace();
		}

		//MAP1
		JobConf mapper1Conf = new JobConf(false);
		ChainMapper.addMapper(conf, Feladat2Mapper1.class, LongWritable.class, Text.class, Text.class, Text.class, true, mapper1Conf);

		
		//MAP2
		JobConf mapper2Conf = new JobConf(false);
		ChainMapper.addMapper(conf, Feladat2Mapper2.class, Text.class, Text.class, Text.class, IntWritable.class, true, mapper2Conf);
		
		//Reducer
		JobConf reducerConf = new JobConf(false);
		ChainReducer.setReducer(conf, Feladat2Reducer.class, Text.class, IntWritable.class, Text.class, IntWritable.class, true, reducerConf);

		//MAP3
		JobConf mapper3Conf = new JobConf(false);
		ChainReducer.addMapper(conf, Feladat2Mapper3.class, Text.class, IntWritable.class, IntWritable.class, Text.class, true, mapper3Conf);

		
		try {
			JobClient.runJob(conf);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
